//*****************************************************************************
//
// Имя файла    : 'loop.cpp'
// Описание     : Драйвер ввода-вывода
// Автор        : Межлумов В.Ш.
//
//*****************************************************************************

#include "loop.h"
#include <QVBoxLayout>
#include <QLabel>
#include <string.h>


// ============================================================================
//                              Константы
// ============================================================================

    #define PLG_NAME                    "loop"
    #define PLG_TITLE                   "Loop"
    #define PLG_DESC                    "Loop description"
    #define PLG_VERSION                 "0.0.1"


// ============================================================================
//
///                              Конструктор
//
// ============================================================================

CDrvLoop::CDrvLoop (QObject* parent) :
    CDriver(parent),
    m_isOpen(false)
{
}


// ============================================================================
///                         Создание нового объекта
// ============================================================================
/// \return     Указатель на созданный объект
// ============================================================================

CDriver* CDrvLoop::NewInstance (void)
{
    return new CDrvLoop( parent() );
}


// ============================================================================
///                     Запрос имени плагина (файла)
// ============================================================================
/// \return     Строка с именем плагина
// ============================================================================

QString CDrvLoop::GetName (void)
{
    return QString(PLG_NAME);
}


// ============================================================================
///                     Запрос версии плагина
// ============================================================================
/// \return     Строка с версией
// ============================================================================

QString CDrvLoop::GetVersion (void)
{
    return QString(PLG_VERSION);
}


// ============================================================================
///                     Запрос названия драйвера
// ============================================================================
/// \return     Строка с названием
// ============================================================================

QString CDrvLoop::GetTitle (void)
{
    return QString(PLG_TITLE);
}


// ============================================================================
///                     Запрос описания драйвера
// ============================================================================
/// \return     Строка с описанием
// ============================================================================

QString CDrvLoop::GetDesc ()
{
    return QString(PLG_DESC);
}


// ============================================================================
///                     Отрисовка параметров драйвера
// ============================================================================
/// \param  widget      Виджет для отрисовки настроек
/// \param  pSettings   Актульные значения конфигурации
// ============================================================================

void CDrvLoop::DrawSettings (QWidget* widget, QHash<QString, QVariant>* pSettings)
{
    Q_UNUSED(pSettings);

    QVBoxLayout* layout = new QVBoxLayout(widget);
    QLabel* label = new QLabel("Loop settings", widget);

    layout->addWidget(label);

    widget->setLayout(layout);
}


// ============================================================================
///                     Сохранение выбранных параметров
// ============================================================================
/// \param  widget      Виджет с настройками настроек
/// \param  pSettings   Хранилище настроек
// ============================================================================

void CDrvLoop::SaveSettings (QWidget* widget, QHash<QString, QVariant>* pSettings)
{
    Q_UNUSED(widget);
    Q_UNUSED(pSettings);
}


// ============================================================================
///                     Конфигурирование драйвера
// ============================================================================
/// \param  params  Конфигурационные параметры
/// \return         0 или отрицательный код ошибки
// ============================================================================

int CDrvLoop::Configure (QHash<QString, QVariant>* params)
{
    if (!m_isOpen) return -1;

    Q_UNUSED(params);
    return 0;
}


// ============================================================================
///                         Открытие устройства
// ============================================================================
/// \return         0 или отрицательный код ошибки
// ============================================================================

int CDrvLoop::Open (void)
{
    m_isOpen = true;
    return 0;
}


// ============================================================================
///                         Закрытие устройства
// ============================================================================
/// \return         0 или отрицательный код ошибки
// ============================================================================

int CDrvLoop::Close (void)
{
    m_isOpen = false;
    return 0;
}


// ============================================================================
///                 Определение состояния устройства
// ============================================================================
/// \return         true - устройство открыто
// ============================================================================

bool CDrvLoop::IsOpen (void)
{
    return m_isOpen;
}


// ============================================================================
///                         Отправка данных
// ============================================================================
/// \param  data    Данные для записи
/// \param  size    Количество данных
// ============================================================================

void CDrvLoop::Send (const char* data, uint size)
{
    if (!m_isOpen) return;

    char* buff = (char*) malloc(size);
    if (!buff) return;
    memcpy(buff, data, size);

    emit Sended(data, size);
    emit Received(buff, size);

    free(buff);
}
